/*
******************************************************************************

   Fallback stubs BLT implementation - header.

   Copyright (C) 2001	Brian S. Julin [bri@tull.umassp.edu]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#include <ggi/internal/blt.h>
#include <ggi/internal/blt_debug.h>

/*
 *	"exported" Function prototypes
 */
BltTie			BLT_stubs_tie;
BltUntie		BLT_stubs_untie;

bo_match_func	BLT_stubs_bo_match;
bo_go_func	BLT_stubs_bo_go;
bo_go_func	BLT_stubs_sink_go;

enum blt_stubs_get {
	BLT_STUBS_GET_NIL = 0,
	BLT_STUBS_GET_VIS = 1,
	BLT_STUBS_GET_PIXBUF_DIRECT = 2,
};

enum blt_stubs_put {
	BLT_STUBS_PUT_NIL = 0,
	BLT_STUBS_PUT_VIS = 1,
	BLT_STUBS_PUT_PIXBUF_DIRECT = 2,
};

struct blt_stubs_row {
	enum blt_stubs_get get1, get2;
	int get1x, get1y, get1stride, get1stackoff;
	void *get1buf;
	enum blt_stubs_put put1, put2;
	int put1x, put1y, put1stride, put1stackoff;
	void *put1buf;
	int stackw;	/* maximum number of consecutive pixels to process */
	int srcw, srch;
};

#define BLT_STUBS_NUMPARMS	10
extern struct batchparm BLT_stubs_bp[BLT_STUBS_NUMPARMS];

#define BLT_stubs_stack_pull 4096
